Index: uspace/srv/logger/logs.c
===================================================================
--- uspace/srv/logger/logs.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/logger/logs.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -52,10 +52,11 @@
 }
 
-static errno_t create_dest(const char *name, logger_dest_t **dest)
+static int create_dest(const char *name, logger_dest_t **dest)
 {
 	logger_dest_t *result = malloc(sizeof(logger_dest_t));
 	if (result == NULL)
 		return ENOMEM;
-	if (asprintf(&result->filename, "/log/%s", name) < 0) {
+	int rc = asprintf(&result->filename, "/log/%s", name);
+	if (rc < 0) {
 		free(result);
 		return ENOMEM;
@@ -86,10 +87,11 @@
 		if (result->full_name == NULL)
 			goto error;
-		errno_t rc = create_dest(name, &result->dest);
+		int rc = create_dest(name, &result->dest);
 		if (rc != EOK)
 			goto error;
 	} else {
-		if (asprintf(&result->full_name, "%s/%s",
-		    parent->full_name, name) < 0)
+		int rc = asprintf(&result->full_name, "%s/%s",
+		    parent->full_name, name);
+		if (rc < 0)
 			goto error;
 		result->dest = parent->dest;
Index: uspace/srv/logger/main.c
===================================================================
--- uspace/srv/logger/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/logger/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -70,17 +70,13 @@
 	
 	port_id_t port;
-	errno_t rc = async_create_port(INTERFACE_LOGGER_CONTROL,
+	int rc = async_create_port(INTERFACE_LOGGER_CONTROL,
 	    connection_handler_control, NULL, &port);
-	if (rc != EOK) {
-		printf("%s: Error while creating control port: %s\n", NAME, str_error(rc));
+	if (rc != EOK)
 		return rc;
-	}
 	
 	rc = async_create_port(INTERFACE_LOGGER_WRITER,
 	    connection_handler_writer, NULL, &port);
-	if (rc != EOK) {
-		printf("%s: Error while creating writer port: %s\n", NAME, str_error(rc));
+	if (rc != EOK)
 		return rc;
-	}
 	
 	rc = service_register(SERVICE_LOGGER);
Index: uspace/srv/logger/writer.c
===================================================================
--- uspace/srv/logger/writer.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/logger/writer.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -53,5 +53,5 @@
 {
 	void *name;
-	errno_t rc = async_data_write_accept(&name, true, 1, 0, 0, NULL);
+	int rc = async_data_write_accept(&name, true, 1, 0, 0, NULL);
 	if (rc != EOK)
 		return NULL;
@@ -64,5 +64,5 @@
 }
 
-static errno_t handle_receive_message(sysarg_t log_id, sysarg_t level)
+static int handle_receive_message(sysarg_t log_id, sysarg_t level)
 {
 	logger_log_t *log = find_log_by_id_and_lock(log_id);
@@ -71,5 +71,5 @@
 
 	void *message = NULL;
-	errno_t rc = async_data_write_accept(&message, true, 1, 0, 0, NULL);
+	int rc = async_data_write_accept(&message, true, 1, 0, 0, NULL);
 	if (rc != EOK)
 		goto leave;
@@ -80,5 +80,5 @@
 	}
 
-	KLOG_PRINTF(level, "[%s] %s: %s",
+	KLOG_PRINTF(level, "[%s] %s: %s\n",
 	    log->full_name, log_level_str(level),
 	    (const char *) message);
@@ -128,5 +128,5 @@
 		}
 		case LOGGER_WRITER_MESSAGE: {
-			errno_t rc = handle_receive_message(IPC_GET_ARG1(call),
+			int rc = handle_receive_message(IPC_GET_ARG1(call),
 			    IPC_GET_ARG2(call));
 			async_answer_0(callid, rc);
Index: uspace/srv/net/dhcp/dhcp.c
===================================================================
--- uspace/srv/net/dhcp/dhcp.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/net/dhcp/dhcp.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,5 +39,4 @@
 #include <byteorder.h>
 #include <errno.h>
-#include <str_error.h>
 #include <fibril_synch.h>
 #include <inet/addr.h>
@@ -48,5 +47,4 @@
 #include <stdio.h>
 #include <stdlib.h>
-#include <str.h>
 
 #include "dhcp.h"
@@ -118,5 +116,5 @@
 
 /** Decode subnet mask into subnet prefix length. */
-static errno_t subnet_mask_decode(uint32_t mask, int *bits)
+static int subnet_mask_decode(uint32_t mask, int *bits)
 {
 	int zbits;
@@ -149,5 +147,5 @@
 }
 
-static errno_t dhcp_send_discover(dhcp_link_t *dlink)
+static int dhcp_send_discover(dhcp_link_t *dlink)
 {
 	dhcp_hdr_t *hdr = (dhcp_hdr_t *)msgbuf;
@@ -172,5 +170,5 @@
 }
 
-static errno_t dhcp_send_request(dhcp_link_t *dlink, dhcp_offer_t *offer)
+static int dhcp_send_request(dhcp_link_t *dlink, dhcp_offer_t *offer)
 {
 	dhcp_hdr_t *hdr = (dhcp_hdr_t *)msgbuf;
@@ -213,5 +211,5 @@
 }
 
-static errno_t dhcp_parse_reply(void *msg, size_t size, dhcp_offer_t *offer)
+static int dhcp_parse_reply(void *msg, size_t size, dhcp_offer_t *offer)
 {
 	dhcp_hdr_t *hdr = (dhcp_hdr_t *)msg;
@@ -226,5 +224,5 @@
 	uint8_t opt_type, opt_len;
 	uint8_t *msgb;
-	errno_t rc;
+	int rc;
 	size_t i;
 
@@ -361,7 +359,7 @@
 }
 
-static errno_t dhcp_cfg_create(service_id_t iplink, dhcp_offer_t *offer)
-{
-	errno_t rc;
+static int dhcp_cfg_create(service_id_t iplink, dhcp_offer_t *offer)
+{
+	int rc;
 	service_id_t addr_id;
 	service_id_t sroute_id;
@@ -372,5 +370,5 @@
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR,
-		    "Error creating IP address %s: %s", "dhcp4a", str_error(rc));
+		    "Error creating IP address %s (%d)", "dhcp4a", rc);
 		return rc;
 	}
@@ -382,5 +380,5 @@
 		if (rc != EOK) {
 			log_msg(LOG_DEFAULT, LVL_ERROR, "Error creating "
-			    "default route %s: %s.", "dhcpdef", str_error(rc));
+			    "default route %s (%d).", "dhcpdef", rc);
 			return rc;
 		}
@@ -391,5 +389,5 @@
 		if (rc != EOK) {
 			log_msg(LOG_DEFAULT, LVL_ERROR, "Error setting "
-			    "nameserver address: %s)", str_error(rc));
+			    "nameserver address (%d))", rc);
 			return rc;
 		}
@@ -421,9 +419,9 @@
 }
 
-static errno_t dhcp_discover_proc(dhcp_link_t *dlink)
+static int dhcp_discover_proc(dhcp_link_t *dlink)
 {
 	dlink->state = ds_selecting;
 
-	errno_t rc = dhcp_send_discover(dlink);
+	int rc = dhcp_send_discover(dlink);
 	if (rc != EOK)
 		return EIO;
@@ -439,8 +437,8 @@
 }
 
-errno_t dhcpsrv_link_add(service_id_t link_id)
+int dhcpsrv_link_add(service_id_t link_id)
 {
 	dhcp_link_t *dlink;
-	errno_t rc;
+	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "dhcpsrv_link_add(%zu)", link_id);
@@ -499,10 +497,10 @@
 }
 
-errno_t dhcpsrv_link_remove(service_id_t link_id)
+int dhcpsrv_link_remove(service_id_t link_id)
 {
 	return ENOTSUP;
 }
 
-errno_t dhcpsrv_discover(service_id_t link_id)
+int dhcpsrv_discover(service_id_t link_id)
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "dhcpsrv_link_add(%zu)", link_id);
@@ -521,5 +519,5 @@
 static void dhcpsrv_recv_offer(dhcp_link_t *dlink, dhcp_offer_t *offer)
 {
-	errno_t rc;
+	int rc;
 
 	if (dlink->state != ds_selecting) {
@@ -547,5 +545,5 @@
 static void dhcpsrv_recv_ack(dhcp_link_t *dlink, dhcp_offer_t *offer)
 {
-	errno_t rc;
+	int rc;
 
 	if (dlink->state != ds_requesting) {
@@ -573,5 +571,5 @@
 	dhcp_link_t *dlink = (dhcp_link_t *)arg;
 	dhcp_offer_t offer;
-	errno_t rc;
+	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "%s: dhcpsrv_recv() %zu bytes",
@@ -601,5 +599,5 @@
 {
 	dhcp_link_t *dlink = (dhcp_link_t *)arg;
-	errno_t rc;
+	int rc;
 
 	assert(dlink->state == ds_selecting);
@@ -629,5 +627,5 @@
 {
 	dhcp_link_t *dlink = (dhcp_link_t *)arg;
-	errno_t rc;
+	int rc;
 
 	assert(dlink->state == ds_requesting);
Index: uspace/srv/net/dhcp/dhcp.h
===================================================================
--- uspace/srv/net/dhcp/dhcp.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/net/dhcp/dhcp.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,7 +41,7 @@
 
 extern void dhcpsrv_links_init(void);
-extern errno_t dhcpsrv_link_add(service_id_t);
-extern errno_t dhcpsrv_link_remove(service_id_t);
-extern errno_t dhcpsrv_discover(service_id_t);
+extern int dhcpsrv_link_add(service_id_t);
+extern int dhcpsrv_link_remove(service_id_t);
+extern int dhcpsrv_discover(service_id_t);
 
 #endif
Index: uspace/srv/net/dhcp/main.c
===================================================================
--- uspace/srv/net/dhcp/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/net/dhcp/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,5 +36,4 @@
 #include <async.h>
 #include <errno.h>
-#include <str_error.h>
 #include <io/log.h>
 #include <inet/inetcfg.h>
@@ -52,7 +51,7 @@
 static void dhcp_client_conn(ipc_callid_t, ipc_call_t *, void *);
 
-static errno_t dhcp_init(void)
+static int dhcp_init(void)
 {
-	errno_t rc;
+	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "dhcp_init()");
@@ -70,5 +69,5 @@
 	rc = loc_server_register(NAME);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server: %s.", str_error(rc));
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server (%d).", rc);
 		return EEXIST;
 	}
@@ -77,5 +76,5 @@
 	rc = loc_service_register(SERVICE_NAME_DHCP, &sid);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service: %s.", str_error(rc));
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service (%d).", rc);
 		return EEXIST;
 	}
@@ -87,5 +86,5 @@
 {
 	sysarg_t link_id;
-	errno_t rc;
+	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "dhcp_link_add_srv()");
@@ -100,5 +99,5 @@
 {
 	sysarg_t link_id;
-	errno_t rc;
+	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "dhcp_link_remove_srv()");
@@ -113,5 +112,5 @@
 {
 	sysarg_t link_id;
-	errno_t rc;
+	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "dhcp_discover_srv()");
@@ -159,5 +158,5 @@
 int main(int argc, char *argv[])
 {
-	errno_t rc;
+	int rc;
 
 	printf("%s: DHCP Service\n", NAME);
Index: uspace/srv/net/dhcp/transport.c
===================================================================
--- uspace/srv/net/dhcp/transport.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/net/dhcp/transport.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -75,8 +75,8 @@
 };
 
-errno_t dhcp_send(dhcp_transport_t *dt, void *msg, size_t size)
+int dhcp_send(dhcp_transport_t *dt, void *msg, size_t size)
 {
 	inet_ep_t ep;
-	errno_t rc;
+	int rc;
 
 	inet_ep_init(&ep);
@@ -97,5 +97,5 @@
 	dhcp_transport_t *dt;
 	size_t s;
-	errno_t rc;
+	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_NOTE, "dhcp_recv_msg()");
@@ -126,5 +126,5 @@
 }
 
-errno_t dhcp_transport_init(dhcp_transport_t *dt, service_id_t link_id,
+int dhcp_transport_init(dhcp_transport_t *dt, service_id_t link_id,
     dhcp_recv_cb_t recv_cb, void *arg)
 {
@@ -132,5 +132,5 @@
 	udp_assoc_t *assoc = NULL;
 	inet_ep2_t epp;
-	errno_t rc;
+	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "dhcp_transport_init()");
Index: uspace/srv/net/dhcp/transport.h
===================================================================
--- uspace/srv/net/dhcp/transport.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/net/dhcp/transport.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -58,8 +58,8 @@
 };
 
-extern errno_t dhcp_transport_init(dhcp_transport_t *, service_id_t,
+extern int dhcp_transport_init(dhcp_transport_t *, service_id_t,
     dhcp_recv_cb_t, void *);
 extern void dhcp_transport_fini(dhcp_transport_t *);
-extern errno_t dhcp_send(dhcp_transport_t *dt, void *msg, size_t size);
+extern int dhcp_send(dhcp_transport_t *dt, void *msg, size_t size);
 
 #endif
Index: uspace/srv/net/dnsrsrv/dns_msg.c
===================================================================
--- uspace/srv/net/dnsrsrv/dns_msg.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/net/dnsrsrv/dns_msg.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -56,5 +56,5 @@
  * fit in and append @a suff.
  */
-static errno_t dns_dstr_ext(char **dstr, const char *suff)
+static int dns_dstr_ext(char **dstr, const char *suff)
 {
 	size_t s1, s2;
@@ -93,5 +93,5 @@
  * @param act_size	Place to store actual encoded size
  */
-static errno_t dns_name_encode(char *name, uint8_t *buf, size_t buf_size,
+static int dns_name_encode(char *name, uint8_t *buf, size_t buf_size,
     size_t *act_size)
 {
@@ -158,5 +158,5 @@
  * @param eoff	Place to store end offset (offset after last decoded byte)
  */
-errno_t dns_name_decode(dns_pdu_t *pdu, size_t boff, char **rname,
+int dns_name_decode(dns_pdu_t *pdu, size_t boff, char **rname,
     size_t *eoff)
 {
@@ -169,5 +169,5 @@
 	char *name;
 	char dbuf[2];
-	errno_t rc;
+	int rc;
 	bool first;
 
@@ -325,10 +325,10 @@
  * @param act_size	Place to store actual encoded size
  */
-static errno_t dns_question_encode(dns_question_t *question, uint8_t *buf,
+static int dns_question_encode(dns_question_t *question, uint8_t *buf,
     size_t buf_size, size_t *act_size)
 {
 	size_t name_size;
 	size_t di;
-	errno_t rc;
+	int rc;
 
 	rc = dns_name_encode(question->qname, buf, buf_size, &name_size);
@@ -358,10 +358,10 @@
  * @param eoff		Place to store end offset (offset after last decoded byte)
  */
-static errno_t dns_question_decode(dns_pdu_t *pdu, size_t boff,
+static int dns_question_decode(dns_pdu_t *pdu, size_t boff,
     dns_question_t **rquestion, size_t *eoff)
 {
 	dns_question_t *question;
 	size_t name_eoff;
-	errno_t rc;
+	int rc;
 
 	question = calloc(1, sizeof (dns_question_t));
@@ -398,5 +398,5 @@
  * @param eoff		Place to store end offset (offset after last decoded byte)
  */
-static errno_t dns_rr_decode(dns_pdu_t *pdu, size_t boff, dns_rr_t **retrr,
+static int dns_rr_decode(dns_pdu_t *pdu, size_t boff, dns_rr_t **retrr,
     size_t *eoff)
 {
@@ -406,5 +406,5 @@
 	size_t bsz;
 	size_t rdlength;
-	errno_t rc;
+	int rc;
 
 	rr = calloc(1, sizeof(dns_rr_t));
@@ -492,5 +492,5 @@
  *		ENOMEM if out of memory
  */
-errno_t dns_message_encode(dns_message_t *msg, void **rdata, size_t *rsize)
+int dns_message_encode(dns_message_t *msg, void **rdata, size_t *rsize)
 {
 	uint8_t *data;
@@ -499,5 +499,5 @@
 	size_t q_size = 0;
 	size_t di;
-	errno_t rc;
+	int rc;
 
 	hdr.id = host2uint16_t_be(msg->id);
@@ -564,5 +564,5 @@
  * 		ENOMEM if out of memory
  */
-errno_t dns_message_decode(void *data, size_t size, dns_message_t **rmsg)
+int dns_message_decode(void *data, size_t size, dns_message_t **rmsg)
 {
 	dns_message_t *msg;
@@ -575,5 +575,5 @@
 	size_t an_count;
 	size_t i;
-	errno_t rc;
+	int rc;
 
 	msg = dns_message_new();
Index: uspace/srv/net/dnsrsrv/dns_msg.h
===================================================================
--- uspace/srv/net/dnsrsrv/dns_msg.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/net/dnsrsrv/dns_msg.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -44,9 +44,9 @@
 #include "dns_type.h"
 
-extern errno_t dns_message_encode(dns_message_t *, void **, size_t *);
-extern errno_t dns_message_decode(void *, size_t, dns_message_t **);
+extern int dns_message_encode(dns_message_t *, void **, size_t *);
+extern int dns_message_decode(void *, size_t, dns_message_t **);
 extern dns_message_t *dns_message_new(void);
 extern void dns_message_destroy(dns_message_t *);
-extern errno_t dns_name_decode(dns_pdu_t *, size_t, char **, size_t *);
+extern int dns_name_decode(dns_pdu_t *, size_t, char **, size_t *);
 extern uint32_t dns_uint32_t_decode(uint8_t *, size_t);
 extern void dns_addr128_t_decode(uint8_t *, size_t, addr128_t);
Index: uspace/srv/net/dnsrsrv/dnsrsrv.c
===================================================================
--- uspace/srv/net/dnsrsrv/dnsrsrv.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/net/dnsrsrv/dnsrsrv.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,5 +36,4 @@
 #include <async.h>
 #include <errno.h>
-#include <str_error.h>
 #include <io/log.h>
 #include <ipc/dnsr.h>
@@ -43,5 +42,4 @@
 #include <stdio.h>
 #include <stdlib.h>
-#include <str.h>
 #include <task.h>
 
@@ -55,7 +53,7 @@
 static void dnsr_client_conn(ipc_callid_t, ipc_call_t *, void *);
 
-static errno_t dnsr_init(void)
-{
-	errno_t rc;
+static int dnsr_init(void)
+{
+	int rc;
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "dnsr_init()");
 
@@ -70,5 +68,5 @@
 	rc = loc_server_register(NAME);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server: %s.", str_error(rc));
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server (%d).", rc);
 		transport_fini();
 		return EEXIST;
@@ -78,5 +76,5 @@
 	rc = loc_service_register(SERVICE_NAME_DNSR, &sid);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service: %s.", str_error(rc));
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service (%d).", rc);
 		transport_fini();
 		return EEXIST;
@@ -94,5 +92,5 @@
 	
 	char *name;
-	errno_t rc = async_data_write_accept((void **) &name, true, 0,
+	int rc = async_data_write_accept((void **) &name, true, 0,
 	    DNS_NAME_MAX_SIZE, 0, NULL);
 	if (rc != EOK) {
@@ -146,5 +144,5 @@
 		async_answer_0(callid, rc);
 	
-	async_answer_0(iid, rc);
+	async_answer_0(iid, (sysarg_t) rc);
 	
 	dns_hostinfo_destroy(hinfo);
@@ -172,5 +170,5 @@
 	// FIXME locking
 	
-	errno_t rc = async_data_read_finalize(callid, &dns_server_addr, size);
+	int rc = async_data_read_finalize(callid, &dns_server_addr, size);
 	if (rc != EOK)
 		async_answer_0(callid, rc);
@@ -200,11 +198,11 @@
 	// FIXME locking
 	
-	errno_t rc = async_data_write_finalize(callid, &dns_server_addr, size);
-	if (rc != EOK) {
-		async_answer_0(callid, rc);
-		async_answer_0(iid, rc);
-	}
-	
-	async_answer_0(iid, rc);
+	int rc = async_data_write_finalize(callid, &dns_server_addr, size);
+	if (rc != EOK) {
+		async_answer_0(callid, rc);
+		async_answer_0(iid, rc);
+	}
+	
+	async_answer_0(iid, (sysarg_t) rc);
 }
 
@@ -247,5 +245,5 @@
 int main(int argc, char *argv[])
 {
-	errno_t rc;
+	int rc;
 
 	printf("%s: DNS Resolution Service\n", NAME);
Index: uspace/srv/net/dnsrsrv/query.c
===================================================================
--- uspace/srv/net/dnsrsrv/query.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/net/dnsrsrv/query.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -47,5 +47,5 @@
 static uint16_t msg_id;
 
-static errno_t dns_name_query(const char *name, dns_qtype_t qtype,
+static int dns_name_query(const char *name, dns_qtype_t qtype,
     dns_host_info_t *info)
 {
@@ -92,5 +92,5 @@
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "dns_name_query: send DNS request");
 	dns_message_t *amsg;
-	errno_t rc = dns_request(msg, &amsg);
+	int rc = dns_request(msg, &amsg);
 	if (rc != EOK) {
 		dns_message_destroy(msg);
@@ -190,5 +190,5 @@
 }
 
-errno_t dns_name2host(const char *name, dns_host_info_t **rinfo, ip_ver_t ver)
+int dns_name2host(const char *name, dns_host_info_t **rinfo, ip_ver_t ver)
 {
 	dns_host_info_t *info = calloc(1, sizeof(dns_host_info_t));
@@ -196,5 +196,5 @@
 		return ENOMEM;
 	
-	errno_t rc;
+	int rc;
 	
 	switch (ver) {
Index: uspace/srv/net/dnsrsrv/query.h
===================================================================
--- uspace/srv/net/dnsrsrv/query.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/net/dnsrsrv/query.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,5 +40,5 @@
 #include "dns_type.h"
 
-extern errno_t dns_name2host(const char *, dns_host_info_t **, ip_ver_t);
+extern int dns_name2host(const char *, dns_host_info_t **, ip_ver_t);
 extern void dns_hostinfo_destroy(dns_host_info_t *);
 
Index: uspace/srv/net/dnsrsrv/transport.c
===================================================================
--- uspace/srv/net/dnsrsrv/transport.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/net/dnsrsrv/transport.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,5 +36,4 @@
 #include <adt/list.h>
 #include <errno.h>
-#include <str_error.h>
 #include <fibril_synch.h>
 #include <inet/addr.h>
@@ -69,5 +68,5 @@
 	fibril_mutex_t done_lock;
 
-	errno_t status;
+	int status;
 } trans_req_t;
 
@@ -90,8 +89,8 @@
 };
 
-errno_t transport_init(void)
+int transport_init(void)
 {
 	inet_ep2_t epp;
-	errno_t rc;
+	int rc;
 
 	inet_ep2_init(&epp);
@@ -177,5 +176,5 @@
 }
 
-errno_t dns_request(dns_message_t *req, dns_message_t **rresp)
+int dns_request(dns_message_t *req, dns_message_t **rresp)
 {
 	trans_req_t *treq = NULL;
@@ -185,5 +184,5 @@
 	size_t req_size;
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "dns_request: Encode dns message");
-	errno_t rc = dns_message_encode(req, &req_data, &req_size);
+	int rc = dns_message_encode(req, &req_data, &req_size);
 	if (rc != EOK)
 		goto error;
@@ -200,5 +199,5 @@
 		    req_size);
 		if (rc != EOK) {
-			log_msg(LOG_DEFAULT, LVL_DEBUG, "Error sending message: %s", str_error(rc));
+			log_msg(LOG_DEFAULT, LVL_DEBUG, "Error %d sending message", rc);
 			goto error;
 		}
@@ -255,5 +254,5 @@
 	size_t size;
 	inet_ep_t remote_ep;
-	errno_t rc;
+	int rc;
 
 	size = udp_rmsg_size(rmsg);
Index: uspace/srv/net/dnsrsrv/transport.h
===================================================================
--- uspace/srv/net/dnsrsrv/transport.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/net/dnsrsrv/transport.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -42,7 +42,7 @@
 extern inet_addr_t dns_server_addr;
 
-extern errno_t transport_init(void);
+extern int transport_init(void);
 extern void transport_fini(void);
-extern errno_t dns_request(dns_message_t *, dns_message_t **);
+extern int dns_request(dns_message_t *, dns_message_t **);
 
 #endif
Index: uspace/srv/net/ethip/arp.c
===================================================================
--- uspace/srv/net/ethip/arp.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/net/ethip/arp.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -50,5 +50,5 @@
 #define ARP_REQUEST_TIMEOUT (3 * 1000 * 1000)
 
-static errno_t arp_send_packet(ethip_nic_t *nic, arp_eth_packet_t *packet);
+static int arp_send_packet(ethip_nic_t *nic, arp_eth_packet_t *packet);
 
 void arp_received(ethip_nic_t *nic, eth_frame_t *frame)
@@ -57,5 +57,5 @@
 	
 	arp_eth_packet_t packet;
-	errno_t rc = arp_pdu_decode(frame->data, frame->size, &packet);
+	int rc = arp_pdu_decode(frame->data, frame->size, &packet);
 	if (rc != EOK)
 		return;
@@ -94,5 +94,5 @@
 }
 
-errno_t arp_translate(ethip_nic_t *nic, addr32_t src_addr, addr32_t ip_addr,
+int arp_translate(ethip_nic_t *nic, addr32_t src_addr, addr32_t ip_addr,
     addr48_t mac_addr)
 {
@@ -103,5 +103,5 @@
 	}
 
-	errno_t rc = atrans_lookup(ip_addr, mac_addr);
+	int rc = atrans_lookup(ip_addr, mac_addr);
 	if (rc == EOK)
 		return EOK;
@@ -122,7 +122,7 @@
 }
 
-static errno_t arp_send_packet(ethip_nic_t *nic, arp_eth_packet_t *packet)
+static int arp_send_packet(ethip_nic_t *nic, arp_eth_packet_t *packet)
 {
-	errno_t rc;
+	int rc;
 	void *pdata;
 	size_t psize;
Index: uspace/srv/net/ethip/arp.h
===================================================================
--- uspace/srv/net/ethip/arp.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/net/ethip/arp.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,5 +43,5 @@
 
 extern void arp_received(ethip_nic_t *, eth_frame_t *);
-extern errno_t arp_translate(ethip_nic_t *, addr32_t, addr32_t, addr48_t);
+extern int arp_translate(ethip_nic_t *, addr32_t, addr32_t, addr48_t);
 
 #endif
Index: uspace/srv/net/ethip/atrans.c
===================================================================
--- uspace/srv/net/ethip/atrans.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/net/ethip/atrans.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -59,5 +59,5 @@
 }
 
-errno_t atrans_add(addr32_t ip_addr, addr48_t mac_addr)
+int atrans_add(addr32_t ip_addr, addr48_t mac_addr)
 {
 	ethip_atrans_t *atrans;
@@ -85,5 +85,5 @@
 }
 
-errno_t atrans_remove(addr32_t ip_addr)
+int atrans_remove(addr32_t ip_addr)
 {
 	ethip_atrans_t *atrans;
@@ -103,5 +103,5 @@
 }
 
-static errno_t atrans_lookup_locked(addr32_t ip_addr, addr48_t mac_addr)
+static int atrans_lookup_locked(addr32_t ip_addr, addr48_t mac_addr)
 {
 	ethip_atrans_t *atrans = atrans_find(ip_addr);
@@ -113,7 +113,7 @@
 }
 
-errno_t atrans_lookup(addr32_t ip_addr, addr48_t mac_addr)
+int atrans_lookup(addr32_t ip_addr, addr48_t mac_addr)
 {
-	errno_t rc;
+	int rc;
 
 	fibril_mutex_lock(&atrans_list_lock);
@@ -134,10 +134,10 @@
 }
 
-errno_t atrans_lookup_timeout(addr32_t ip_addr, suseconds_t timeout,
+int atrans_lookup_timeout(addr32_t ip_addr, suseconds_t timeout,
     addr48_t mac_addr)
 {
 	fibril_timer_t *t;
 	bool timedout;
-	errno_t rc;
+	int rc;
 
 	t = fibril_timer_create(NULL);
Index: uspace/srv/net/ethip/atrans.h
===================================================================
--- uspace/srv/net/ethip/atrans.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/net/ethip/atrans.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -42,8 +42,8 @@
 #include "ethip.h"
 
-extern errno_t atrans_add(addr32_t, addr48_t);
-extern errno_t atrans_remove(addr32_t);
-extern errno_t atrans_lookup(addr32_t, addr48_t);
-extern errno_t atrans_lookup_timeout(addr32_t, suseconds_t, addr48_t);
+extern int atrans_add(addr32_t, addr48_t);
+extern int atrans_remove(addr32_t);
+extern int atrans_lookup(addr32_t, addr48_t);
+extern int atrans_lookup_timeout(addr32_t, suseconds_t, addr48_t);
 
 #endif
Index: uspace/srv/net/ethip/ethip.c
===================================================================
--- uspace/srv/net/ethip/ethip.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/net/ethip/ethip.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -53,13 +53,13 @@
 #define NAME "ethip"
 
-static errno_t ethip_open(iplink_srv_t *srv);
-static errno_t ethip_close(iplink_srv_t *srv);
-static errno_t ethip_send(iplink_srv_t *srv, iplink_sdu_t *sdu);
-static errno_t ethip_send6(iplink_srv_t *srv, iplink_sdu6_t *sdu);
-static errno_t ethip_get_mtu(iplink_srv_t *srv, size_t *mtu);
-static errno_t ethip_get_mac48(iplink_srv_t *srv, addr48_t *mac);
-static errno_t ethip_set_mac48(iplink_srv_t *srv, addr48_t *mac);
-static errno_t ethip_addr_add(iplink_srv_t *srv, inet_addr_t *addr);
-static errno_t ethip_addr_remove(iplink_srv_t *srv, inet_addr_t *addr);
+static int ethip_open(iplink_srv_t *srv);
+static int ethip_close(iplink_srv_t *srv);
+static int ethip_send(iplink_srv_t *srv, iplink_sdu_t *sdu);
+static int ethip_send6(iplink_srv_t *srv, iplink_sdu6_t *sdu);
+static int ethip_get_mtu(iplink_srv_t *srv, size_t *mtu);
+static int ethip_get_mac48(iplink_srv_t *srv, addr48_t *mac);
+static int ethip_set_mac48(iplink_srv_t *srv, addr48_t *mac);
+static int ethip_addr_add(iplink_srv_t *srv, inet_addr_t *addr);
+static int ethip_addr_remove(iplink_srv_t *srv, inet_addr_t *addr);
 
 static void ethip_client_conn(ipc_callid_t iid, ipc_call_t *icall, void *arg);
@@ -77,9 +77,9 @@
 };
 
-static errno_t ethip_init(void)
+static int ethip_init(void)
 {
 	async_set_fallback_port_handler(ethip_client_conn, NULL);
 	
-	errno_t rc = loc_server_register(NAME);
+	int rc = loc_server_register(NAME);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server.");
@@ -94,7 +94,7 @@
 }
 
-errno_t ethip_iplink_init(ethip_nic_t *nic)
-{
-	errno_t rc;
+int ethip_iplink_init(ethip_nic_t *nic)
+{
+	int rc;
 	service_id_t sid;
 	category_id_t iplink_cat;
@@ -108,7 +108,7 @@
 	nic->iplink.arg = nic;
 
-	if (asprintf(&svc_name, "net/eth%u", ++link_num) < 0) {
+	rc = asprintf(&svc_name, "net/eth%u", ++link_num);
+	if (rc < 0) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Out of memory.");
-		rc = ENOMEM;
 		goto error;
 	}
@@ -158,5 +158,5 @@
 }
 
-static errno_t ethip_open(iplink_srv_t *srv)
+static int ethip_open(iplink_srv_t *srv)
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "ethip_open()");
@@ -164,5 +164,5 @@
 }
 
-static errno_t ethip_close(iplink_srv_t *srv)
+static int ethip_close(iplink_srv_t *srv)
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "ethip_close()");
@@ -170,5 +170,5 @@
 }
 
-static errno_t ethip_send(iplink_srv_t *srv, iplink_sdu_t *sdu)
+static int ethip_send(iplink_srv_t *srv, iplink_sdu_t *sdu)
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "ethip_send()");
@@ -177,5 +177,5 @@
 	eth_frame_t frame;
 	
-	errno_t rc = arp_translate(nic, sdu->src, sdu->dest, frame.dest);
+	int rc = arp_translate(nic, sdu->src, sdu->dest, frame.dest);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_WARN, "Failed to look up IPv4 address 0x%"
@@ -201,5 +201,5 @@
 }
 
-static errno_t ethip_send6(iplink_srv_t *srv, iplink_sdu6_t *sdu)
+static int ethip_send6(iplink_srv_t *srv, iplink_sdu6_t *sdu)
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "ethip_send6()");
@@ -216,5 +216,5 @@
 	void *data;
 	size_t size;
-	errno_t rc = eth_pdu_encode(&frame, &data, &size);
+	int rc = eth_pdu_encode(&frame, &data, &size);
 	if (rc != EOK)
 		return rc;
@@ -226,5 +226,5 @@
 }
 
-errno_t ethip_received(iplink_srv_t *srv, void *data, size_t size)
+int ethip_received(iplink_srv_t *srv, void *data, size_t size)
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "ethip_received(): srv=%p", srv);
@@ -234,5 +234,5 @@
 	
 	eth_frame_t frame;
-	errno_t rc = eth_pdu_decode(data, size, &frame);
+	int rc = eth_pdu_decode(data, size, &frame);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_DEBUG, " - eth_pdu_decode failed");
@@ -269,5 +269,5 @@
 }
 
-static errno_t ethip_get_mtu(iplink_srv_t *srv, size_t *mtu)
+static int ethip_get_mtu(iplink_srv_t *srv, size_t *mtu)
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "ethip_get_mtu()");
@@ -276,5 +276,5 @@
 }
 
-static errno_t ethip_get_mac48(iplink_srv_t *srv, addr48_t *mac)
+static int ethip_get_mac48(iplink_srv_t *srv, addr48_t *mac)
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "ethip_get_mac48()");
@@ -286,5 +286,5 @@
 }
 
-static errno_t ethip_set_mac48(iplink_srv_t *srv, addr48_t *mac)
+static int ethip_set_mac48(iplink_srv_t *srv, addr48_t *mac)
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "ethip_set_mac48()");
@@ -296,5 +296,5 @@
 }
 
-static errno_t ethip_addr_add(iplink_srv_t *srv, inet_addr_t *addr)
+static int ethip_addr_add(iplink_srv_t *srv, inet_addr_t *addr)
 {
 	ethip_nic_t *nic = (ethip_nic_t *) srv->arg;
@@ -303,5 +303,5 @@
 }
 
-static errno_t ethip_addr_remove(iplink_srv_t *srv, inet_addr_t *addr)
+static int ethip_addr_remove(iplink_srv_t *srv, inet_addr_t *addr)
 {
 	ethip_nic_t *nic = (ethip_nic_t *) srv->arg;
@@ -312,5 +312,5 @@
 int main(int argc, char *argv[])
 {
-	errno_t rc;
+	int rc;
 
 	printf(NAME ": HelenOS IP over Ethernet service\n");
Index: uspace/srv/net/ethip/ethip.h
===================================================================
--- uspace/srv/net/ethip/ethip.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/net/ethip/ethip.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -116,6 +116,6 @@
 } ethip_atrans_t;
 
-extern errno_t ethip_iplink_init(ethip_nic_t *);
-extern errno_t ethip_received(iplink_srv_t *, void *, size_t);
+extern int ethip_iplink_init(ethip_nic_t *);
+extern int ethip_received(iplink_srv_t *, void *, size_t);
 
 #endif
